searchData={"content_type":"text/markdown","items":[{"doc":"Ecto adapter for Amazon DynamoDB.","ref":"Ecto.Adapters.DynamoDB.html","title":"Ecto.Adapters.DynamoDB","type":"module"},{"doc":"Called to autogenerate a value for id/embed_id/binary_id.\n\nReturns the autogenerated value, or nil if it must be\nautogenerated inside the storage or raise if not supported.\n\nFor the Ecto type, `:id`, the adapter autogenerates a 128-bit integer\n\nFor the Ecto type, `:embed_id`, the adapter autogenerates a string, using `Ecto.UUID.generate()`\n\nFor the Ecto type, `:binary_id`, the adapter autogenerates a string, using `Ecto.UUID.generate()`","ref":"Ecto.Adapters.DynamoDB.html#autogenerate/1","title":"Ecto.Adapters.DynamoDB.autogenerate/1","type":"function"},{"doc":"Returns the dumpers for a given type.\n\nWe rely on ExAws encoding functionality during insertion and update to properly format types for DynamoDB. Please see ExAws `ExAws.Dynamo.update_item` and `ExAws.Dynamo.put_item` for specifics. Currently, we only modify :utc_datetime and :naive_datetime, appending the UTC offset, \"Z\", to the datetime string before passing to ExAws.","ref":"Ecto.Adapters.DynamoDB.html#dumpers/2","title":"Ecto.Adapters.DynamoDB.dumpers/2","type":"function"},{"doc":"Logs message to console and optionally to file. Log levels, colours and file path may be set in configuration (details in README.md).","ref":"Ecto.Adapters.DynamoDB.html#ecto_dynamo_log/4","title":"Ecto.Adapters.DynamoDB.ecto_dynamo_log/4","type":"function"},{"doc":"Ensure all applications necessary to run the adapter are started.","ref":"Ecto.Adapters.DynamoDB.html#ensure_all_started/2","title":"Ecto.Adapters.DynamoDB.ensure_all_started/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.html#ex_aws_config/1","title":"Ecto.Adapters.DynamoDB.ex_aws_config/1","type":"function"},{"doc":"Executes a previously prepared query.\n\nIt must return a tuple containing the number of entries and\nthe result set as a list of lists. The result set may also be\n`nil` if a particular operation does not support them.\n\nThe `meta` field is a map containing some of the fields found\nin the `Ecto.Query` struct.\n\nIt receives a process function that should be invoked for each\nselected field in the query result in order to convert them to the\nexpected Ecto type. The `process` function will be nil if no\nresult set is expected from the query.","ref":"Ecto.Adapters.DynamoDB.html#execute/5","title":"Ecto.Adapters.DynamoDB.execute/5","type":"function"},{"doc":"Inserts a single new struct in the data store.","ref":"Ecto.Adapters.DynamoDB.html#insert/6","title":"Ecto.Adapters.DynamoDB.insert/6","type":"function"},{"doc":"The primary key will be automatically included in `returning` if the\nfield has type `:id` or `:binary_id` and no value was set by the\ndeveloper or none was autogenerated by the adapter.","ref":"Ecto.Adapters.DynamoDB.html#insert/6-autogenerate","title":"Autogenerate - Ecto.Adapters.DynamoDB.insert/6","type":"function"},{"doc":"Returns the loaders for a given type.\n\nRather than use the Ecto adapter loaders callback, the adapter builds on ExAws' decoding functionality, please see ExAws's `ExAws.Dynamo.Decoder`, in this module, which at this time only loads :utc_datetime and :naive_datetime.","ref":"Ecto.Adapters.DynamoDB.html#loaders/2","title":"Ecto.Adapters.DynamoDB.loaders/2","type":"function"},{"doc":"Commands invoked to prepare a query for `all`, `update_all` and `delete_all`.\n\nThe returned result is given to `execute/6`.","ref":"Ecto.Adapters.DynamoDB.html#prepare/2","title":"Ecto.Adapters.DynamoDB.prepare/2","type":"function"},{"doc":"An Elixir agent to cache DynamoDB table schemas and the first page of results for selected tables","ref":"Ecto.Adapters.DynamoDB.Cache.html","title":"Ecto.Adapters.DynamoDB.Cache","type":"module"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#child_spec/1","title":"Ecto.Adapters.DynamoDB.Cache.child_spec/1","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#describe_table/2","title":"Ecto.Adapters.DynamoDB.Cache.describe_table/2","type":"function"},{"doc":"Returns the cached value for a call to DynamoDB, describe-table. Performs a DynamoDB scan if not yet cached and raises any errors as a result of the request. The raw json is presented as an elixir map.","ref":"Ecto.Adapters.DynamoDB.Cache.html#describe_table!/2","title":"Ecto.Adapters.DynamoDB.Cache.describe_table!/2","type":"function"},{"doc":"Returns the current cache of table schemas, and cache of first page of results for selected tables, as an Elixir map","ref":"Ecto.Adapters.DynamoDB.Cache.html#get_cache/1","title":"Ecto.Adapters.DynamoDB.Cache.get_cache/1","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#scan/2","title":"Ecto.Adapters.DynamoDB.Cache.scan/2","type":"function"},{"doc":"Returns the cached first page of results for a table. Performs a DynamoDB scan if not yet cached and raises any errors as a result of the request","ref":"Ecto.Adapters.DynamoDB.Cache.html#scan!/2","title":"Ecto.Adapters.DynamoDB.Cache.scan!/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#start_link/1","title":"Ecto.Adapters.DynamoDB.Cache.start_link/1","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#update_cached_table/2","title":"Ecto.Adapters.DynamoDB.Cache.update_cached_table/2","type":"function"},{"doc":"Performs a DynamoDB scan and caches (without returning) the first page of results. Raises any errors as a result of the request","ref":"Ecto.Adapters.DynamoDB.Cache.html#update_cached_table!/2","title":"Ecto.Adapters.DynamoDB.Cache.update_cached_table!/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#update_table_info/2","title":"Ecto.Adapters.DynamoDB.Cache.update_table_info/2","type":"function"},{"doc":"Performs a DynamoDB, describe-table, and caches (without returning) the result. Raises any errors as a result of the request","ref":"Ecto.Adapters.DynamoDB.Cache.html#update_table_info!/2","title":"Ecto.Adapters.DynamoDB.Cache.update_table_info!/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#t:cached_table/0","title":"Ecto.Adapters.DynamoDB.Cache.cached_table/0","type":"type"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Cache.html#t:t/0","title":"Ecto.Adapters.DynamoDB.Cache.t/0","type":"type"},{"doc":"An Ecto type for handling MapSet, corresponding with DynamoDB's **set** types. Since ExAws\nalready encodes and decodes MapSet, we only handle casting and validation here.","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html","title":"Ecto.Adapters.DynamoDB.DynamoDBSet","type":"module"},{"doc":"Confirm the type is a MapSet and its elements are of one type, number or binary","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html#cast/1","title":"Ecto.Adapters.DynamoDB.DynamoDBSet.cast/1","type":"function"},{"doc":"Dump as is","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html#dump/1","title":"Ecto.Adapters.DynamoDB.DynamoDBSet.dump/1","type":"function"},{"doc":"Dictates how the type should be treated inside embeds","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html#embed_as/1","title":"Ecto.Adapters.DynamoDB.DynamoDBSet.embed_as/1","type":"function"},{"doc":"Check if two terms are semantically equal","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html#equal?/2","title":"Ecto.Adapters.DynamoDB.DynamoDBSet.equal?/2","type":"function"},{"doc":"Load as is","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html#load/1","title":"Ecto.Adapters.DynamoDB.DynamoDBSet.load/1","type":"function"},{"doc":"This type is actually a MapSet","ref":"Ecto.Adapters.DynamoDB.DynamoDBSet.html#type/0","title":"Ecto.Adapters.DynamoDB.DynamoDBSet.type/0","type":"function"},{"doc":"Get information on dynamo tables and schema","ref":"Ecto.Adapters.DynamoDB.Info.html","title":"Ecto.Adapters.DynamoDB.Info","type":"module"},{"doc":"Get all the raw information on indexes for a given table, returning as a map.","ref":"Ecto.Adapters.DynamoDB.Info.html#index_details/2","title":"Ecto.Adapters.DynamoDB.Info.index_details/2","type":"function"},{"doc":"returns a list of any indexed attributes in the table","ref":"Ecto.Adapters.DynamoDB.Info.html#indexed_attributes/2","title":"Ecto.Adapters.DynamoDB.Info.indexed_attributes/2","type":"function"},{"doc":"Get a list of the available indexes on a table. The format of this list is described in normalise_dynamo_index!","ref":"Ecto.Adapters.DynamoDB.Info.html#indexes/2","title":"Ecto.Adapters.DynamoDB.Info.indexes/2","type":"function"},{"doc":"Returns the primary key/ID for a table. It may be a single field that is a HASH, OR\nit may be the dynamoDB {HASH, SORT} type of index. we return\n\\{:primary, [index]}\nin a format described in normalise_dynamo_index!","ref":"Ecto.Adapters.DynamoDB.Info.html#primary_key!/2","title":"Ecto.Adapters.DynamoDB.Info.primary_key!/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Info.html#repo_primary_key/1","title":"Ecto.Adapters.DynamoDB.Info.repo_primary_key/1","type":"function"},{"doc":"returns a simple list of the secondary indexes (global and local) for the table. Uses same format\nfor each member of the list as 'primary_key!'.","ref":"Ecto.Adapters.DynamoDB.Info.html#secondary_indexes/2","title":"Ecto.Adapters.DynamoDB.Info.secondary_indexes/2","type":"function"},{"doc":"Returns the raw amazon dynamo DB table schema information. The raw json is presented as an elixir map.\n\nHere is an example of what it may look like\n```\n%{\"AttributeDefinitions\" => [%{\"AttributeName\" => \"id\",\n     \"AttributeType\" => \"S\"},\n   %{\"AttributeName\" => \"person_id\", \"AttributeType\" => \"S\"}],\n  \"CreationDateTime\" => 1489615412.651,\n  \"GlobalSecondaryIndexes\" => [%{\"IndexArn\" => \"arn:aws:dynamodb:ddblocal:000000000000:table/circle_members/index/person_id\",\n     \"IndexName\" => \"person_id\", \"IndexSizeBytes\" => 7109,\n     \"IndexStatus\" => \"ACTIVE\", \"ItemCount\" => 146,\n     \"KeySchema\" => [%{\"AttributeName\" => \"person_id\", \"KeyType\" => \"HASH\"}],\n     \"Projection\" => %{\"ProjectionType\" => \"ALL\"},\n     \"ProvisionedThroughput\" => %{\"ReadCapacityUnits\" => 100,\n       \"WriteCapacityUnits\" => 50}}], \"ItemCount\" => 146,\n  \"KeySchema\" => [%{\"AttributeName\" => \"id\", \"KeyType\" => \"HASH\"},\n   %{\"AttributeName\" => \"person_id\", \"KeyType\" => \"RANGE\"}],\n  \"ProvisionedThroughput\" => %{\"LastDecreaseDateTime\" => 0.0,\n    \"LastIncreaseDateTime\" => 0.0, \"NumberOfDecreasesToday\" => 0,\n    \"ReadCapacityUnits\" => 100, \"WriteCapacityUnits\" => 50},\n  \"TableArn\" => \"arn:aws:dynamodb:ddblocal:000000000000:table/circle_members\",\n  \"TableName\" => \"circle_members\", \"TableSizeBytes\" => 7109,\n  \"TableStatus\" => \"ACTIVE\"}\n```","ref":"Ecto.Adapters.DynamoDB.Info.html#table_info/2","title":"Ecto.Adapters.DynamoDB.Info.table_info/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Info.html#ttl_info/2","title":"Ecto.Adapters.DynamoDB.Info.ttl_info/2","type":"function"},{"doc":"Implements Ecto migrations for `create table` and `alter table`.\n\nThe functions, `add`, `remove` and `modify` correspond to indexes on the DynamoDB table. Using `add`, the second parameter, field type (which corresponds with the DynamoDB attribute) must be specified. Use the third parameter to specify a primary key not already specified. For a HASH-only primary key, use `primary_key: true` as the third parameter. For a composite primary key (HASH and RANGE), in addition to the `primary_key` specification, set the third parameter on the range key attribute to `range_key: true`. There should be only one primary key (hash or composite) specified per table.\n\nTo specify index details, such as provisioned throughput, create_if_not_exists/drop_if_exists, billing_mode, and global and local indexes, use the `options` keyword in `create table` and `alter table`, please see the examples below for greater detail.\n\n*Please note that `change` may not work as expected on rollback. We recommend specifying `up` and `down` instead.*\n\n```\nExample:\n\n# Migration file 1:\n\n  def change do\n    create table(:post,\n      primary_key: false,\n      options: [\n        global_indexes: [\n          [index_name: \"email_content\",\n           keys: [:email, :content],\n           provisioned_throughput: [100, 100]] # [read_capacity, write_capacity]\n          ],\n        provisioned_throughput: [20,20]\n      ]) do\n\n      add :email,   :string, primary_key: true  # primary composite key\n      add :title,   :string, range_key: true    # primary composite key\n      add :content, :string\n    end\n  end\n\n\n# Migration file 2:\n\n  def up do\n    create_if_not_exists table(:rabbit,\n      primary_key: false,\n      options: [\n        billing_mode: :pay_per_request,\n        global_indexes: [\n          [index_name: \"name\",\n            keys: [:name]]\n        ]\n      ]) do\n\n      add :id, :string, primary_key: true\n      add :name, :string, hash_key: true\n    end\n  end\n\n  def down do\n    drop_if_exists table(:rabbit)\n  end\n\n\n# Migration file 3:\n\n  def up do\n    alter table(:post,\n      options: [\n        global_indexes: [\n          [index_name: \"content\",\n           keys: [:content],\n           create_if_not_exists: true,\n           provisioned_throughput: [1,1],\n           projection: [projection_type: :include, non_key_attributes: [:email]]]\n        ]\n      ]) do\n\n      add :content, string\n    end\n  end\n\n  def down do\n    alter table(:post,\n      options: [\n        global_indexes: [\n          [index_name: \"content\",\n            drop_if_exists: true]]\n      ]\n    ) do\n      remove :content\n    end\n  end\n\n\n# Migration file 4:\n\n  def up do\n    alter table(:post) do\n      # modify will not be processed in a rollback if 'change' is used\n      modify :\"email_content\", :string, provisioned_throughput: [2,2]\n      remove :content\n    end\n  end\n\n  def down do\n    alter table(:post,\n      options: [\n        global_indexes: [\n          [index_name: \"content\",\n           keys: [:content],\n           projection: [projection_type: :include, non_key_attributes: [:email]]]\n        ]\n      ]) do\n\n      modify :\"email_content\", :string, provisioned_throughput: [100,100]\n      add :content, :string\n    end\n  end\n```","ref":"Ecto.Adapters.DynamoDB.Migration.html","title":"Ecto.Adapters.DynamoDB.Migration","type":"module"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Migration.html#execute_ddl/3","title":"Ecto.Adapters.DynamoDB.Migration.execute_ddl/3","type":"function"},{"doc":"Some query wrapper functions for helping us query dynamo db. Selects indexes to use, etc.\nNot to be confused with `Ecto.Query`.","ref":"Ecto.Adapters.DynamoDB.Query.html","title":"Ecto.Adapters.DynamoDB.Query","type":"module"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Query.html#construct_search/3","title":"Ecto.Adapters.DynamoDB.Query.construct_search/3","type":"function"},{"doc":"Given a map with a search criteria, finds the best index to search against it.\nReturns a tuple indicating whether it's a primary key index, or a secondary index.\nTo query against a secondary index in Dynamo, we NEED to have it's index name,\nso secondary indexes are returned as a tuple with the field name, whilst\nthe primary key uses the atom :primary to distinguish it.\n\n  {:primary, [indexed_fields_list]} | {\"index_name\", [indexed_fields_list]}\n\nException if the index doesn't exist.","ref":"Ecto.Adapters.DynamoDB.Query.html#get_best_index/4","title":"Ecto.Adapters.DynamoDB.Query.get_best_index/4","type":"function"},{"doc":"Same as get_best_index, but refers to a scan option on failure","ref":"Ecto.Adapters.DynamoDB.Query.html#get_best_index!/4","title":"Ecto.Adapters.DynamoDB.Query.get_best_index!/4","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Query.html#get_item/4","title":"Ecto.Adapters.DynamoDB.Query.get_item/4","type":"function"},{"doc":"Given a search criteria of 1 or more fields, we try find out if the primary key is a\ngood match and can be used to forfill this search. Returns the tuple \n  {:primary, [hash] | [hash, range]}\nor \n  :not_found","ref":"Ecto.Adapters.DynamoDB.Query.html#get_matching_primary_index/3","title":"Ecto.Adapters.DynamoDB.Query.get_matching_primary_index/3","type":"function"},{"doc":"Given a keyword list containing search field, value and operator to search for (which may also be nested under logical operators, e.g., `[{\"id\", {\"franko\", :==}}]`, or `[{:and, [{\"circle_id\", {\"123\", :==}}, {\"person_id\", {\"abc\", :>}}]}`), will return the dynamo db index description that will help us match this search. return :not_found if no index is found.\n\nReturns a tuple of {\"index_name\", [ hash_key or hash,range_key]]} or :not_found\nTODO: Does not help with range queries. -> The match_index_hash_part function is\n  beginning to address this.","ref":"Ecto.Adapters.DynamoDB.Query.html#get_matching_secondary_index/4","title":"Ecto.Adapters.DynamoDB.Query.get_matching_secondary_index/4","type":"function"},{"doc":"Formats the recursive option according to whether the query is a DynamoDB scan or query. (The adapter defaults to recursive fetch in case of the latter but not the former)","ref":"Ecto.Adapters.DynamoDB.Query.html#parse_recursive_option/2","title":"Ecto.Adapters.DynamoDB.Query.parse_recursive_option/2","type":"function"},{"doc":"Returns an atom, :scan or :query, specifying whether the current search will be a DynamoDB scan or a query.","ref":"Ecto.Adapters.DynamoDB.Query.html#scan_or_query?/3","title":"Ecto.Adapters.DynamoDB.Query.scan_or_query?/3","type":"function"},{"doc":"Updates the recursive option during a recursive fetch, according to whether the option is a boolean or an integer (as in the case of page_limit)","ref":"Ecto.Adapters.DynamoDB.Query.html#update_recursive_option/1","title":"Ecto.Adapters.DynamoDB.Query.update_recursive_option/1","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.Query.html#t:expression_data_acc/0","title":"Ecto.Adapters.DynamoDB.Query.expression_data_acc/0","type":"type"},{"doc":"An Elixir agent to optionally record DynamoDB query information (like LastEvaluatedKey) that's not part of expected Ecto return values.","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html","title":"Ecto.Adapters.DynamoDB.QueryInfo","type":"module"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#child_spec/1","title":"Ecto.Adapters.DynamoDB.QueryInfo.child_spec/1","type":"function"},{"doc":"Returns the value (query info) in the QueryInfo agent associated with the provided key.","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#get/1","title":"Ecto.Adapters.DynamoDB.QueryInfo.get/1","type":"function"},{"doc":"Provides a random 32 character, base 64 encoded string.","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#get_key/0","title":"Ecto.Adapters.DynamoDB.QueryInfo.get_key/0","type":"function"},{"doc":"Returns the complete current map recorded by the agent.","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#get_map/0","title":"Ecto.Adapters.DynamoDB.QueryInfo.get_map/0","type":"function"},{"doc":"Updates the value of a given key in the Agent map.","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#put/2","title":"Ecto.Adapters.DynamoDB.QueryInfo.put/2","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#start_link/0","title":"Ecto.Adapters.DynamoDB.QueryInfo.start_link/0","type":"function"},{"doc":"Updates the value of a given key in the Agent map according to a specific function.","ref":"Ecto.Adapters.DynamoDB.QueryInfo.html#update/3","title":"Ecto.Adapters.DynamoDB.QueryInfo.update/3","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.RepoConfig.html","title":"Ecto.Adapters.DynamoDB.RepoConfig","type":"module"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.RepoConfig.html#config_val/3","title":"Ecto.Adapters.DynamoDB.RepoConfig.config_val/3","type":"function"},{"doc":"","ref":"Ecto.Adapters.DynamoDB.RepoConfig.html#table_in_list?/3","title":"Ecto.Adapters.DynamoDB.RepoConfig.table_in_list?/3","type":"function"},{"doc":"# Ecto.Adapters.DynamoDB\n[![Hex.pm](https://img.shields.io/hexpm/v/ecto_adapters_dynamodb.svg)](https://hex.pm/packages/ecto_adapters_dynamodb)\n[![Build Docs](https://img.shields.io/badge/hexdocs-release-blue.svg)](https://hexdocs.pm/ecto_adapters_dynamodb/Ecto.Adapters.DynamoDB.html)\n\nThis is a partial implementation of an Elixir Ecto adapter for Amazon's DynamoDB. It's very much a work in progress, and has plenty of rough edges. It's complete enough that we're actually using it in other projects, so we're opening it up to the community in hopes that others will find it useful as well :-)\n\nKeep in mind that DynamoDB is a key-value store designed for very high scale, while the Ecto abstractions are primarily designed to work with relational databases. As such, we've had to make significant compromises in the implementation of this adapter to make it work. Please understand that, while we are using it in production, it should be considered **beta** - **do not deploy it without thoroughly testing it for your use cases.**\n\nIf you wish to contribute, please run `$ mix test` and confirm that the test results are error-free before you push your commits. (Bonus points for improving our tests and adding your own tests for your changes. Patches with corresponding tests are more likely to be accepted, especially if they are significant.)\n\n#","ref":"readme.html","title":"Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We use [ExAws](https://github.com/CargoSense/ex_aws/) to wrap the actual DynamoDB API and requests. This project would not be possible without the extensive work in ExAws.\n\n#","ref":"readme.html#special-thanks-to-exaws-project","title":"Special thanks to ExAws project - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"There are a lot of common things you can do in Ecto with a SQL database that you just can't do (or can't do efficiently) with DynamoDB. If you expect to pick up your existing Ecto-based app and just swap in DynamoDB, you're going to be disappointed. You still have to use this adapter the same way you would approach using a key-value store, and avoid the kinds of patterns you'd use with a relational database.\n\n##","ref":"readme.html#design-limitations","title":"Design limitations - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"It may not be. Understand the DynamoDB limitations. It's designed for very high scale, throughput, and reliability. As a result of this design, there are many kinds of operations that are impossible. Other things are technically possible but not advisable, due to high costs in terms of performance and/or money.\n\nA good starting point is Amazon's own documentation:\n[Amazon: Best Practices for DynamoDB](http://docs.aws.amazon.com/amazondynamodb/latest/developerguide/BestPractices.html)\n\nOur philosophy when creating this adapter can generally be summed up as:\n\n *Try to do what the end user will expect the adapter to do, **unless** it's likely to ruin DynamoDB's performance.*\n\nAn example of this is our handling of table scans (see below).\n\nLastly, please read and understand how DynamoDB and its queries and indexes work. If you don't, then a lot of the following behaviour is going to seem random, and you'll be frustrated trying to figure out why things don't work the way you expect them to. We've done our best to simplify what we can, but underneath it all, it's still DynamoDB.\n\n##","ref":"readme.html#is-dynamodb-the-right-choice-for-you","title":"Is DynamoDB the right choice for you? - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"In DynamoDB, we can fetch individual records or batches of records *very* quickly if we know the primary key to look up, or the key of an indexed field. We **can't** easily perform queries which don't have a simple key or ID to look up:\n\nWill work: (note that this will be a *case sensitive* match as well.)\n\n`select * from people where name = 'ALICE'`\n\nWon't Work:\n\n`select * from people where name like 'Ali%'`\n\n(Obviously these are SQL queries, not Ecto queries, but the above examples just provide a general illustration of what sorts of limitations to expect.)\n\nWe will try our best to parse queries and find any relevant DynamoDB indexes that exists (this includes both HASH indexes, and HASH+RANGE indexes). As long as the `FROM` clause contains at least **one** HASH key from a DynamoDB index, a query will be constructed using our best guess at the most specific matching index (this may not be the best index - unlike a SQL server, we don't understand the data in the table, so the adapter may have to guess - although users can specify the index for queries where the index may be ambiguous, more on that below). Any other fields in the `FROM` criteria will be converted to DynamoDB filters as required to ensure you only get back the data you requested. We also support `is_nil` in queries. This will test whether the attribute is either set to `null` *or* whether the attribute is missing from the record altogether. Please note that DynamoDB does not allow for this type of filtering on attributes that are being queried against, whether in the primary key or in a secondary index.\n\nIf we do not find any matching table index for the query (either a HASH key of an index or the HASH part of a composite HASH+RANGE key), the query will fail by default. It is possible to override this behaviour and have the adapter perform a DynamoDB *scan* instead. Since scans do not scale well, they can potentially be very costly with large data sets, and we have configured the adapter not to scan unless scanning is explicitly enabled. This can be done via global configuration options, or inline as an option to `Repo.all` and other query functions. See the section below on **scan** for more info.\n\nThe adapter will query DynamoDB for a list of indexes and indexed fields on the table, and by default it will cache the results to avoid the overhead of repeatedly pulling the same lists of indexes on every query. This does mean that if you update the indexes on a table in DynamoDB, you will need to execute the **Ecto.Adapters.DynamoDB.Cache.update_table_info!** function or restart the adapter.\n\n###","ref":"readme.html#how-we-use-indexes","title":"How we use indexes - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"When querying a table (`from f in Foo, where: ...`), the adapter's default behavior is to automatically select the \"best\" index on which to query based on the fields in the query. A few things to note:\n\n- A hash-only index will be preferred over a composite index with the **same** hash key if only the hash key field is represented in the query. For example, if you have a `Person` model with a hash-only key on `first_name` and a composite key on `first_name, last_name`, a query that only includes `first_name` will use the hash-only index; a query with both fields will use the composite. While this probably seems like expected behavior, consider what will happen if the range key from the composite index is not a required field in your application; a query that includes both `first_name` and `last_name` **will not** include records where the range key is `nil` (as that record hasn't been added to that index), but a query that does not include `last_name` **will** return those records.\n\n- In the event that a query should include two fields fields that are represented by a hash-only index and the hash portion of a composite index, the hash-only index will always be chosen. Again, consider a `Person` model with a hash-only `first_name` index and a composite `last_name, email` index; a query that includes `first_name` and `last_name` will use the hash-only `first_name` index.\n\nSo in general, expect the adapter to prefer hash-only indexes where they could be seen as best-representing a query.\n\n**Lesson:** create your data models and queries carefully.\n\n##","ref":"readme.html#secondary-index-selection-default-behavior","title":"Secondary index selection - default behavior - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Fetching records based on a hash of the primary key allows DynamoDB to distribute its data across many partitions on many servers, resulting in high scalability and reliability. It also means that you can't do arbitrary queries based on unindexed fields.\n\nWell, that's not quite true, but running queries against un-indexed fields is usually a terrible idea. We can translate queries without any matching indexes to a DynamoDB `scan` operation, but this is not recommended as it can easily burn through all your read capacity. By default, attempting to perform these kinds of queries will raise an error. You can allow them to succeed by enabling the `scan` option at the adapter level for all queries, or by specifying the corresponding option on individual queries. See 'scan' options below for more information.\n\nIf you need to do this a lot, you're losing most of the benefits of DynamoDB, so think carefully before you do.\n\n##","ref":"readme.html#limited-support-for-fetching-all-records-scan-disabled-by-default","title":"Limited support for fetching all records - 'scan' disabled by default - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"DynamoDB does not support joins. Thus, neither do we. Pretty simple.\n\nWhile it's technically possible for us to decompose the query into multiple individual requests against each table and then perform the join ourselves, this will likely result in very poor performance, and burning through excess read units to do so. It's better to construct these 'joins' manually using key/value lookups against indexes carefully chosen to preserve your predictable key/value store performance.\n\nThis is one of those things that are technically possible, but would result in very unpredictable performance that could drag down your entire app, reducing or eliminating any benefit from DynamoDB. You're probably better off using another DB if this is a requirement.\n\nThat said, for very simple joins that match a limited number of keys where all the relevant fields are indexed, joins could probably be emulated pretty reasonably. We'd entertain the notion of accepting a patch for this, if anyone wants to go to the trouble, and if the code contains some reasonable safeguards to avoid executing big, expensive joins by accident. It would be tricky though, and it's certainly not a priority for us right now.\n\n##","ref":"readme.html#no-joins","title":"No joins - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"DynamoDB can ONLY return sorted results if there is a matching HASH+RANGE index where the desired sort key is the RANGE portion of the index. In this case we support the **:scan_index_forward** [option](http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Query.html) as a parameter to Repo queries. However, writing queries like `SELECT * FROM person ORDER BY last_name LIMIT 50` may not be practical; we'd have to retrieve every record from the table to do this. (See also *DynamoDB LIMIT & Paging* below.)\n\nFrom DynamoDB's [Query API](http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Query.html):\n>Query results are always sorted by the sort key value. If the data type of the sort key is Number, the results are returned in numeric order; otherwise, the results are returned in order of UTF-8 bytes. By default, the sort order is ascending. To reverse the order, set the `ScanIndexForward` parameter to false.\n\n##","ref":"readme.html#limited-sorting","title":"Limited sorting - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We currently support both `update` and `update_all` with some performance caveats. Since DynamoDB currently does not offer a batch update operation, we emulate it in `update_all` (and `update` if the full primary key is not provided). The adapter first fetches the query results to get all the relevant keys, then updates the records one by one (paging as it goes, see *DynamoDB LIMIT & Paging* below). Consequently, performance might be slower than expected due to the need to execute individual fetches followed by individual inserts. Also please note that this means that update operations are *not atomic*! Multiple concurrent updates to the same record can race with each other, causing some updates to be silently lost.\n\nAll of these caveats can be especially pernicious if you're performing eventually consistent reads, as is the default for DynamoDB: you could write a new version of a record to a key, then attempt to perform an update to the same key, which could read from a zone that hasn't received your write yet. This would cause the update's fetch to return an older version of the record, which will then be modified and written back to DDB, overwriting your changes from the previous write! Thus, even if a single client synchronously updates a key, waits for success, then does another update, you may still experience a complete loss of the first of those two updates! \n\n**Lesson:** be really careful with updates; and, you may want to use consistent reads unless you really know what you're doing (see the `consistent_read` option for more info).\n\n##","ref":"readme.html#update-support","title":"Update support - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We currently support DynamoDB's **BatchWriteItem** via Ecto's `insert_all` and `delete_all`. DynamoDB enforces a limit of 25 records maximum per batch write, but we allow for an unlimited number of records by chunking large groups.\n\n##","ref":"readme.html#dynamodb-batchwriteitem","title":"DynamoDB BatchWriteItem - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We currently support DynamoDB's **BatchGetItem** via an **:in** clause in `all` queries - for example, `Repo.all(from m in Model, where: m.id in [\"id_1\", \"id_2\"])` or `Repo.all(from m in Model, where: m.id in ^model_ids)`. For tables with a composite primary key, range keys must be supplied in another **:in** clause in matching order - for example, `TestRepo.all(from bp in BookPage, where: bp.id in [\"page:test-1\", \"page:test-2\"] and bp.page_num in [1, 2])`. DynamoDB enforces a limit of 100 records per batch get, but we allow for an unlimited number of records by chunking large groups into separate requests.\n\n##","ref":"readme.html#dynamodb-batchgetitem","title":"DynamoDB BatchGetItem - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"By default, we configure the adapter to fetch all pages recursively for a DynamoDB `query` operation, and to *not* fetch all pages recursively in the case of a DynamoDB `scan` operation. This default can be overridden with the inline **:recursive** and **:page_limit** options (see below). We do not respond to the Ecto `limit` option; rather, we support a **:scan_limit** option, which corresponds with DynamoDB's [limit option](http://docs.aws.amazon.com/amazondynamodb/latest/developerguide/Query.html#Query.Limit), limiting \"the number of items that it returns in the result.\"\n\n##","ref":"readme.html#dynamodb-limit-paging","title":"DynamoDB LIMIT & Paging - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We only launch one instance of ExAws application (and have not yet investigated running multiple instances). This means we can only point to a single amazon Dynamo instance. It's currently not possible to run against two different amazon AWS accounts concurrently. Hopefully this won't be a problem for most users.\n\n##","ref":"readme.html#only-one-dynamodb-adapter-can-be-configured","title":"Only ONE DynamoDB adapter can be configured - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We support Ecto migration tasks via **create_table**, **create_if_not_exists_table**, and **alter_table** only. The functions `add`, `remove` and `modify` work with corresponding *indexes* on the DynamoDB table, rather than columns (as they would in a relational database). The adapter will automatically wait and retry requests when encountering DynamoDB errors that have \"OK to retry? Yes\" listed in the DynamoDB docs, according to an exponential backoff schedule. Since working with DynamoDB indexes and describing tables includes many options outside of Ecto's scope, for our supported syntax, please see details and examples in the **Ecto.Adapters.DynamoDB.Migration** moduledoc, as well as the configuration options, **:migration_initial_wait**, **:migration_wait_exponent**, **:migration_max_wait**, **:migration_table_capacity**.\n\nPlease note: Ecto migration calls `Repo.all()` on the *schema_migrations* table, which corresponds with a DynamoDB scan. To run migrations, add `\"schema_migrations\"` (or the alternate name you've configured for it) in the configuration file to the config variable **:scan_tables**. Additionally, note that the creation of the schema-migration records table takes time - if you have not created it yourself already, we recommend running `mix ecto.migrate --step 0`, then confirming the table is up, which will prevent the adapter from attempting to retrieve records from the schema-migrations table before it's ready.\n\n#","ref":"readme.html#adapter-migration","title":"Adapter.Migration - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"While the previous section listed limitations that we're unlikely to work around due to philosophical differences between DynamoDB as a key/value store vs an SQL relational database, there are some features that we just haven't implemented yet. Feel free to help out if any of these are important to you!\n\n##","ref":"readme.html#unimplemented-features","title":"Unimplemented Features - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"DynamoDB and [ExAws.Dynamo](https://github.com/ex-aws/ex_aws_dynamo) support transactions, but they have not yet been implemented in this adapter. We will probably try to implement transactions at some point, but it's not a high priority for us - if you would like to make a valuable contribution to this project, you could help us to resolve [this issue](https://github.com/circles-learning-labs/ecto_adapters_dynamodb/issues/12).\n\n##","ref":"readme.html#transactions","title":"Transactions - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"In the current release, we do not support Adapter.Storage callbacks.\n\n##","ref":"readme.html#adapter-storage","title":"Adapter.Storage - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"To be honest, we don't even know what this is for. So it's not going to work :)\n\n##","ref":"readme.html#adapter-structure","title":"Adapter.Structure - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"While we've not tested these, without joins it's unlikely they work well (if at all).\n\n##","ref":"readme.html#associations-embeds","title":"Associations & Embeds - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"This callback was implemented under Ecto 3 - it does not seem to be critical for this adapter's behaviour, and we do not know if it is appropriate to implement for DynamoDB. If you have input on this, or you want to help out with its implementation, see the issue [here](https://github.com/circles-learning-labs/ecto_adapters_dynamodb/issues/34).\n\n##","ref":"readme.html#ecto-adapter-migration-lock_for_migrations-4","title":"Ecto.Adapter.Migration.lock_for_migrations/4 - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"This callback was implemented under Ecto 3 - it does not seem to be critical for this adapter's behaviour, and we do not know if it is appropriate to implement for DynamoDB. If you have input on this, or you want to help out with its implementation, see the issue [here](https://github.com/circles-learning-labs/ecto_adapters_dynamodb/issues/33).\n\n##","ref":"readme.html#ecto-adapter-checkout-3","title":"Ecto.Adapter.checkout/3 - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"This callback was implemented under Ecto 3 - it does not seem to be critical for this adapter's behaviour, and we do not know if it is appropriate to implement for DynamoDB. If you have input on this, or you want to help out with its implementation, see the issue [here](https://github.com/circles-learning-labs/ecto_adapters_dynamodb/issues/32).\n\n#","ref":"readme.html#ecto-adapter-queryable-stream-5","title":"Ecto.Adapter.Queryable.stream/5 - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Well, basic CRUD really, which is all you should really expect from a key/value store :).\n\nGet, Insert, Delete and Update. As long as it's simple queries against single tables, it's probably going to work. Anything beyond that probably isn't. All of the following Ecto functions should work to some extent, if not necessarily in every scenario.\n\n* all/2\n* delete/2\n* delete!/2\n* delete_all/2\n* get/3\n* get!/3\n* get_by/3\n* get_by!/3\n* insert/2\n* insert!/2\n* insert_all/3\n* one/2\n* one!/2\n* update/2\n* update!/2\n* update_all/3\n\n##","ref":"readme.html#so-what-does-work","title":"So what DOES work? - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"In late 2018, Amazon introduced a new billing option for tables that allows users to specify table billing as *pay per request* (AKA \"on-demand\") as well as *provisioned* - [more info](https://aws.amazon.com/dynamodb/pricing/on-demand/) - our migrations support both of these options. See `lib/ecto_adapters_dynamodb/migration.ex` for examples.","ref":"readme.html#migrations","title":"Migrations - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Install the [Hex](https://hex.pm/packages/ecto_adapters_dynamodb) package by adding `ecto_adapters_dynamodb` to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:ecto_adapters_dynamodb, \"~> 3.1\"}\n  ]\nend\n```\n\nOtherwise, to fetch from GitHub:\n\n```elixir\ndefp deps do\n  [\n    {:ecto_adapters_dynamodb, git: \"https://github.com/circles-learning-labs/ecto_adapters_dynamodb\", tag: \"3.1.2\"}\n  ]\nend\n```\n\n#","ref":"readme.html#installation","title":"Installation - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"In order to make sure your local version of DynamoDB is up to date with the current production features, please use the latest release of DynamoDB local. As of spring 2020, the latest version is `1.11.478`, released on January 16, 2020.\n\n#","ref":"readme.html#local-dynamodb-version","title":"Local DynamoDB version - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Configuring a repository to use the DynamoDB ecto adapter is pretty similar to most other Ecto adapters - you'll set the `adapter` option in your app's Repo configuration file to `Ecto.Adapters.DynamoDB`, and then set the required (or optional) values in a keyword list in the appropriate application configuration files for your repo.\n\nThese values are **different** from the normal Ecto options. For example, in DynamoDB you don't have `username`, `password`, or `database` options - you'll need to delete these lines. Instead you'll add Amazon `access_key_id`, `secret_access_key`, `region`, and the optional `dynamodb` `host` and `scheme` options if you're not running against the default live Amazon instances (for example, running the local Amazon dev version of DynamoDB for testing and development).\n\nAll these options are quietly passed through to ExAws. Prior to version 3, existing ExAws configuration would be overwritten by these options. From version 3, the options are only used in calls made by the adapter, and other global ExAws configuration is maintained. See [ExAws Getting Started](https://hexdocs.pm/ex_aws/ExAws.html#module-getting-started) for more information on these options.\n\nA note on `access_key_id` and `secret_access_key`: This can simply be the actual key string, or it can be set to pull these from environment variables or Amazon roles (as per ExAws configuration). Some basic examples follow.\n\nYou may also omit all these ExAws options from the adapter config if you wish to configure ExAws manually (for example if you're using other features from ExAws such as S3, or dynamo_streams).\n\nNote that as of version 3, with the exception of logging configuration, all config options are set *per-repo*.\n\nThe adapter also supports [Confex](https://hexdocs.pm/confex)-style configuration options.\n\n**config/config.exs**\n\nInclude the repo module that's configured for the adapter among the project's Ecto repos:\n\n```elixir\nconfig :my_app, ecto_repos: [MyApp.Repo]\n```\n\n**repo module**\n\nConfigure your app's repo module to use `Ecto.Adapters.DynamoDB` as its `:adapter`:\n\n```elixir\ndefmodule MyApp.Repo do\n  use Ecto.Repo,\n    otp_app: :my_app,\n    adapter: Ecto.Adapters.DynamoDB\nend\n```\n\n**Supervisor**\n\nAdd the repo to your app's **Supervisor** configuration:\n\n```elixir\ndefmodule MyApp do\n  def start(_type, _args) do\n    children = [\n      MyApp.Repo\n    ]\n\n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\n**mix.exs**\n\nStart your app by adding it to the `:mod` key under `application`:\n\n```elixir\ndef application do\n  [\n    mod: {MyApp, []}\n  ]\nend\n```\n\nDepending on your app's configuration, you may need to add `:ecto_adapters_dynamodb` under `:extra_applications`.\n\n##","ref":"readme.html#configuration","title":"Configuration - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"For development, we use the [local version](http://docs.aws.amazon.com/amazondynamodb/latest/developerguide/DynamoDBLocal.html) of DynamoDB, and some dummy variable assignments. Note that the access key/secret here are hardcoded in to the config, and that we set a `dynamo` key that overrides the connection parameters from the defaults for AWS. We point it to `localhost:8000` - the default for a local DynamoDB test server.\n\n**config/dev.exs**\n\n```elixir\nconfig :my_app, MyApp.Repo,\n  # ExAws configuration\n  access_key_id: \"abcd\",\n  secret_access_key: \"1234\",\n  region: \"us-east-1\",\n  debug_requests: true,\t# ExAws option to enable debug on aws http request.\n  dynamodb: [\n    scheme: \"http://\",\n    host: \"localhost\",\n    port: 8000,\n    region: \"us-east-1\"\n  ]\n```\n\n##","ref":"readme.html#configuring-a-development-environment-against-a-local-instance-of-dynamo","title":"Configuring a Development Environment against a local instance of Dynamo - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"For a production setup, it's much simpler. No need to specify the `host`/`port` for `dynamodb`, as it will default to the appropriate AWS service in the region selected.\n\nIn this example configuration we do not hard code the secret or access key. These following settings tell ExAws to first attempt to pull the secret and access key from environment variables labelled `AWS_ACCESS_KEY_ID` and `AWS_SECRET_ACCESS_KEY`. If it cannot find those environment variables, it will attempt to fall back on AWS role-based authentication (this only applies if this instance is running in an appropriately configured Amazon instance).\n\nTo reiterate, this is just standard ExAws configuration that we're wrapping up in our adapter config. Please consult the ExAws docs for further information.\n\n**config/prod.exs**\n\n```elixir\nconfig :my_app, MyApp.Repo,\n  # ExAws configuration\n  access_key_id: [{:system, \"AWS_ACCESS_KEY_ID\"}, :instance_role],\n  secret_access_key: [{:system, \"AWS_SECRET_ACCESS_KEY\"}, :instance_role],\n  region: \"us-east-1\"\n```\n\n#","ref":"readme.html#configuring-a-production-environment-using-dynamo-running-on-aws","title":"Configuring a Production environment using Dynamo running on AWS - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"The following are adapter options that apply to the Ecto adapter, and are NOT related to ExAws configuration. They control certain behavioural aspects for the driver, enabling and disabling default behaviours and features on queries.\n\n```elixir\nconfig :my_app, MyApp.Repo\n  dynamodb_local: true,\n  insert_nil_fields: false,\n  remove_nil_fields_on_update: true,\n  cached_tables: [\"colour\"]\n```\n\nThe above snippet will (1) notify the adapter that you are running it against a local dev instance of DynamoDB, (2) set the adapter to ignore fields that are set to `nil` in the changeset, inserting the record without those attributes, (3) set the adapter to remove attributes in a record during an update where those fields are set to `nil` in the changeset, and (4) cache scan results from the \"colour\" table, providing the cached result in subsequent calls. More details for each of those options follow.\n\n##","ref":"readme.html#other-adapter-options","title":"Other adapter options - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"**:dynamodb_local** :: boolean, *default:* `false`\n\nIndicate whether you are running against production (default) or local DynamoDB. The local development version of DynamoDB is not a true replica of the software used in production, and some local behaviours require special handling - in some scenarios for instance, production DynamoDB will raise an error whereas the local version will just hang until it times out. We **strongly** recommend setting this config value to `true` in any environment you will be running against local DynamoDB.\n\nHere's an illustration of a situation where this will be useful:\n\nA developer writes a migration that creates a new table set to the \"provisioned\" billing mode and runs the migration locally and in production. Several months (and several migrations) later, an administrator changes the billing mode for the table from \"provisioned\" to \"on-demand\" via the AWS dashboard. The developer is asked to add a new index to the table, and she writes a migration for the index that does not specify provisioned throughput. Since the production table is now \"on-demand\", the index will run against production without issue; however, her local table is still set to \"provisioned\". In production, attempting to add an index with no specified throughput to a \"provisioned\" table will raise the error\n\n```\n(ExAws.Error) ExAws Request Error! {\"ValidationException\", \"One or more parameter values were invalid: Both ReadCapacityUnits and WriteCapacityUnits must be specified for index: index_name\"}\n```\n\nbut local DynamoDB will hang until it times out and the migration will not be run.\n\nIt is our opinion that the developer in this scenario would want to be able to run the migration locally without necessarily having to change the billing mode of the table, since there is no local equivalent of the AWS dashboard and rewriting/rerunning migrations may be undesirable or impractical. Instead, by setting `dynamodb_local: true`, this adapter will \"ignore\" the discrepancy by quietly adding default provisioned throughput to the index, allowing the developer to continue her work while keeping her local migrations in sync with production.\n\nNot to put too fine a point on it, but attempting to run a migration to add an index with provisioned throughput to an \"on-demand\" table in production will raise the error\n\n```\n(ExAws.Error) ExAws Request Error! {\"ValidationException\", \"One or more parameter values were invalid: Neither ReadCapacityUnits nor WriteCapacityUnits can be specified for index: name when BillingMode is PAY_PER_REQUEST\"}\n```\n\nwhereas local DynamoDB will simply ignore the throughput and proceed to add the index anyway... so setting this value in your configuration will help to ensure uniform behavior when migrating indexes.\n\n#### `nil` value handling options\n\n**:insert_nil_fields** :: boolean, *default:* `true`\n\nDetermines if fields in the changeset with `nil` values will be inserted as DynamoDB `null` values or not set at all. This option is also available inline per query. Please note that DynamoDB does not allow setting indexed attributes to `null` and will respond with an error. It does allow removal of those attributes.\n\n**:remove_nil_fields_on_update** :: boolean, *default:* `false`\n\nDetermines if, during **Repo.update** or **Repo.update_all**, fields in the changeset with `nil` values will be removed from the record/s or set to the DynamoDB `null` value. This option is also available inline per query.\n\n**:empty_mapset_to_nil** :: boolean, *default:* `false`\n\nWhen a field contains a `DynamoDBSet` type and has a MapSet in it, by default the mapset must contain one or more values, otherwise an `insert` on the object will fail. This is due to DynamoDB not supporting empty sets. Setting this value to `true` will convert empty mapset values to `nil` before writing, allowing them to be written to DynamoDB as a null value.\n\n**:nil_to_empty_mapset** :: boolean, *default:* `false`\n\nWhen a field contains a `DynmamoDBSet` type, and the value in DynamoDB is null, setting this option causes the loaded value to be populated with an empty MapSet (the result of `MapSet.new()`) rather than being left as `nil`.\n\n##","ref":"readme.html#production-dynamodb-vs-local-development-dynamodb","title":"Production DynamoDB vs. local development DynamoDB - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"**:scan_tables** :: [string], *default:* `[]`\n\nA list of table names for tables pre-approved for a DynamoDB **scan** command in case an indexed field is not provided in the query *wheres*. By default, scans are completely disabled on all tables. Use this option carefully; you may be better off using the inline query options to make sure you only perform table scans when you explicitly expect to do so.\n\n**:scan_limit** :: integer, *default:* `100`\n\nSets the default limit on the number of records scanned when calling DynamoDB's **scan** command. This can be overridden by the inline **:scan_limit** option. Included as **limit** in the DynamoDB query. (This option does not apply to queries performing recursive fetches.)\n\n**:scan_all** :: boolean, *default:* `false`\n\nPre-approves all tables for a DynamoDB **scan** command in case an indexed field is not provided in the query *wheres*.\n\n**:cached_tables** :: [string], *default:* `[]`\n\nA list of table names for tables assigned for caching of the first page of results (without setting DynamoDB's **limit** parameter in the scan request). For a set table, call `Repo.all(Model)` to cache the first page of results. To override the caching for a table in this list, and perform a regular scan with associated inline options (see below), provide an additional `scan: true` option with the query; for example, `Repo.all(Model, scan: true, recursive: true)`.\n\n##","ref":"readme.html#scan-related-options","title":"Scan-related options - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"**:migration_source** :: string, *default:* `\"schema_migrations\"`\n\nThe name of the table that should be used for tracking schema migrations.\n\n**:migration_initial_wait** :: integer, *default:* `1000`\n\nThe time in milliseconds of the first wait period before retrying a DynamoDB **create_table** or **update_table** request.\n\n**:migration_wait_exponent** :: float, *default:* `1.05`\n\nThe exponent to which the wait time between sequential retries of **create_table** or **update_table** requests is raised.\n\n**:migration_max_wait** :: integer, *default:* `15000`\n\nThe maximum wait time in milliseconds over sequential retries of a particular **create_table** or **update_table** request. Set this to `0` to avoid retries altogether. \n\n**:migration_table_capacity** :: [integer, integer], *default:* `[1,1]`\n\nProvisionedThroughput as `[ReadCapacityUnits, WriteCapacityUnits]`, for the Schema Migrations table only, automatically created by Ecto if it does not exist.\n\n##","ref":"readme.html#migration-related-options","title":"Migration-related options - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"As of 3.3.4, setting the `use_logger` configuration option to `true` will to write logs using Elixir's built-in `Logger` system. This setting causes all other log-related settings below to be ignored, and\ninstead has behaviour dictated by `Logger`'s configuration.\n\nIf `use_logger` is not set, the adapter's logging options are configured during compile time, and can be altered in the application's configuration files (`config/config.exs`, `config/dev.exs`, `config/test.exs` and `config/test.exs`). To enable logging in colour, the `MIX_ENV` environment variable must be explicitly exported as `dev` during compilation.\n\nWe provide a few informational log lines, such as which adapter call is being processed, as well as the table, lookup fields, and options detected. Configure an optional log path to have the messages recorded on file.\n\nNote that logging configuration is at the adapter level and is common to all repos.\n\n**:log_levels** :: `[:info, :debug]`, *default:* `[:info]`\n\n**:log_colours** :: %{log-level-atom: IO.ANSI-colour-atom}, *default:* `info: :green, debug: :normal`\n\n**:log_path** :: string, *default:* `\"\"`\n\nExample:\n\n```elixir\nconfig :ecto_adapters_dynamodb,\n  log_levels: [:info, :debug]\n```","ref":"readme.html#logging-configuration","title":"Logging Configuration - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"The adapter supports a mix of Ecto options and custom inline options; if the Ecto option is not listed here, assume the adapter will ignore it. The following options can be passed during runtime in the Ecto calls. For example, consider a DynamoDB table with a composite index (HASH+RANGE):\n\n```elixir\nMyApp.Repo.all(\n  (from MyApp.HikingTrip, where: [location_id: \"grand_canyon\"]),\n  recursive: false,\n  scan_limit: 5\n)\n```\n\nwill retrieve the first five results from the record set for the indexed HASH, \"location_id\" = \"grand_canyon\", disabling the default recursive page fetch for queries. (Please note that without `recursive: false`, the adapter would ignore the scan limit.)\n\n#","ref":"readme.html#inline-options","title":"Inline Options - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"**:on_conflict** :: `:raise | :nothing | :replace_all`, *default:* `:raise`\n\nBy default, the adapter will provide the condition expression, `attribute_not_exists(PARTITION_KEY_ATTRIBUTE)` with the DynamoDB query, failing to insert if the record already exists. To perform an unconditional insert, possibly overwriting an existing record, provide the option `on_conflict: :replace_all` in the insert query. If `on_conflict: :nothing` is provided, a struct will be returned, although the record will not be inserted if there is a preexisting record with the same primary key.\n\n#","ref":"readme.html#supported-ecto-options","title":"Supported Ecto Options - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"#### **Inline Options:** *Repo.update*, *Repo.delete*\n\n**:range_key** :: `{attribute_name_atom, value}`, *default:* none\n\nIf the DynamoDB table queried has a composite primary key, an update or delete query must supply both the `HASH` and the `RANGE` parts of the key. We assume that your Ecto model schema will correlate its primary id with DynamoDB's `HASH` part of the key. However, since Ecto will normally only supply the adapter with the primary id along with the changeset, we offer the `range_key` option to avoid an extra query to retrieve the complete key. The adapter will attempt to query the table for the complete key if the **:range_key** option is not supplied.\n\n#### **Inline Options:** *Repo.update_all*\n\n**:add / :delete** :: `[{field_atom, MapSet}]`, *default:* none\n\nEcto does not currently support `:push` and `:pull` on fields that are not `:array` type. To perform DynamoDB's **add** and **delete** on sets, pass the action, field, and value as an option.\n\n**:prepend_to_list** :: `[field_atom]`, *default:* none\n\nTo prepend a value during a `:push` action, include the field in this option. For example:\n\n`Repo.update_all((from Country, where: [name: \"New Zealand\"]), [push: [tags: \"adventure\"]], prepend_to_list: [:tags])`\n\n**:pull_indexes** :: `[{field_atom, [integer]}]`, *default:* none\n\nTo remove an element in a DynamoDB list, we must supply the list index of the element/s. Include them in this option. If `:pull_indexes` is not specified, the adapter will attempt to find and remove all the occurrences of the value in the `:pull` keyword in the corresponding list field.\n\nHere's an example including both of the options above:\n\n```elixir\nRepo.update_all(\n  (from Model, where: [id: \"fffx\"]), \n  [set: [name: \"Speedy\"], inc: [int_field: 2], pull: [list_field_1: \"value to remove\"], list_field_2: \"value will be ignored\"],\n  add: [set_field_1: MapSet.new([\"add_this\"])], delete: [set_field_2: MapSet.new([\"remove_this\"])], pull_indexes: [list_field_2: [5]]\n)\n```\n\n##","ref":"readme.html#custom-inline-options","title":"Custom Inline Options - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"For convenience, we have added an Ecto type, **Ecto.Adapters.DynamoDB.DynamoDBSet**, which casts and validates an Elixir MapSet type. Once you've included it in your schema, or extended the Ecto.Type behaviour to MapSet, Ecto Repo insert, update, and get commands; and the adapter's DynamoDb set related options, `:add` and `:delete` (mentioned in, *Inline Options: Repo.update_all*) will apply to the MapSet type.\n\nHere's an example of how to declare the DynamoDBSet type in an Ecto schema:\n\n```elixir\ndefmodule Model do\n  use Ecto.Schema\n  \n  schema \"model\" do\n    ...\n    field :set, Ecto.Adapters.DynamoDB.DynamoDBSet\n    ...\n```\n\n#### **Inline Options:** *Repo.all, Repo.update_all, Repo.delete_all*\n\n**:scan_limit** :: integer, *default:* none, except configuration default applies to the DynamoDB `scan` command\n\nSets the limit on the number of records scanned in the current query. Included as **limit** in the DynamoDB query.\n\n**:scan** :: boolean, *default:* `false` (also depends on scan-related configuration)\n\nApproves a DynamoDB **scan** command for the current query in case an indexed field is not provided in the query *wheres*.\n\n**:exclusive_start_key** :: [key_atom: value], *default:* none\n\nAdds DynamoDB's **ExclusiveStartKey** to the current query, providing a starting offset.\n\n**:scan_index_forward** :: boolean, *default:* none\n\nAdds DynamoDB's **ScanIndexForward** to the current query, specifying ascending (true/default) or descending (false) traversal of the index. (Quoted from DynamoDB's [documentation](http://docs.aws.amazon.com/sdkfornet1/latest/apidocs/html/P_Amazon_DynamoDBv2_Model_QueryRequest_ScanIndexForward.htm).)\n\n**:consistent_read** :: boolean, *default:* none\n\nIf set to `true`, then the operation uses strongly consistent reads; otherwise, eventually consistent reads are used. Strongly consistent reads are not supported on global secondary indexes. If you query a global secondary index with ConsistentRead set to `true`, you will receive an error message. (Quoted from DynamoDB's [documentation](http://docs.aws.amazon.com/sdkfornet1/latest/apidocs/html/P_Amazon_DynamoDBv2_Model_QueryRequest_ConsistentRead.htm).)\n\n**:recursive** :: boolean, *default:* `true`, except for DynamoDB `scan` where default is `false`\n\nFetches all pages recursively and performs the relevant operation on results in the case of *Repo.update_all* and *Repo.delete_all*\n\n**:page_limit** :: integer, *default:* none\n\nSets the maximum number of pages to access. The query will execute recursively until the page limit has been reached or there are no more pages (overrides **:recursive** option).\n\n**:index** :: string | atom, *default:* none\n\nWhen querying on a secondary index, this option allows a user to explicitly set the index on which to query by providing the name of that index. In most query cases, the adapter will be able to select the \"best\" index to use without this option, but there are some scenarios where the choice may be ambiguous, such as a query on `first_name` and `last_name` where the indexes `first_name_last_name` and `last_name_first_name` both exist. Without passing an `:index` option in such cases, the adapter may arbitrarily select one index over the other, and consistent results can not be guaranteed. This is especially important when a query includes operations that are specific to either hash or range key behaviors such as `:in`, which will work when applied to hash keys but will break for range keys.\n\n##","ref":"readme.html#dynamodbset","title":"DynamoDBSet - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"**:query_info_key** :: string, *default:* none\n\nIf you would like the query information provided by DynamoDB (for example, to retrieve the LastEvaluatedKey even when no results are returned from the current page), include the option, **query_info_key:** *key_string*.\n\nAfter the query is completed, retrieve the query info from the adapter's **QueryInfo** agent (the key is automatically deleted from the agent upon retrieval):\n\n`Ecto.Adapters.DynamoDB.QueryInfo.get(key_string)`\n\nThe returned map corresponds with DynamoDB's return values:\n\n`%{\"Count\" => 10, \"LastEvaluatedKey\" => %{\"id\" => %{\"S\" => \"6814\"}}, \"ScannedCount\" => 100}`\n\n**Ecto.Adapters.DynamoDB.QueryInfo.get_key** provides a 32-character random string for convenience.\n\n#### **Inline Options:** *Repo.insert, Repo.insert_all*\n\n**:insert_nil_fields** :: boolean, *default:* set in configuration\n\nDetermines if fields in the changeset with `nil` values will be inserted as DynamoDB `null` values or not set at all.\n\n#### **Inline Options:** *Repo.update, Repo.update_all*\n\n**:remove_nil_fields** :: boolean, *default:* set in configuration\n\nDetermines if fields in the changeset with `nil` values will be removed from the record/s or set to the DynamoDB `null` value.\n\n#","ref":"readme.html#queryinfo-agent","title":"QueryInfo agent - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"We currently only support the Ecto fragments of the form:\n\n`from(m in Model, where: fragment(\"? between ? and ?\", m.attribute, ^range_start, ^range_end))`\n\n`from(m in Model, where: fragment(\"begins_with(?, ?)\", m.attribute, ^prefix))`","ref":"readme.html#dynamodb-between-and-ecto-fragment","title":"DynamoDB `between` and Ecto `:fragment` - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"The adapter automatically caches its own calls to **describe_table** for retrieval of table information. We also offer the option to configure tables for scan caching. To update the cache after making a change in a table, the cache offers two functions:\n\n**Ecto.Adapters.DynamoDB.Cache.update_table_info!(table_name)**, *table_name* :: string\n\nThis re-fetches and caches the index data for the given table.\n\n**Ecto.Adapters.DynamoDB.Cache.update_cached_table!(table_name)**, *table_name* :: string\n\nThis runs a scan against the given table and updates the in-memory cached copy of it.","ref":"readme.html#caching","title":"Caching - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"The **projection_expression** option is used internally during **delete_all** to select only the key attributes and is recognized during query construction.\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc) and published on [HexDocs](https://hexdocs.pm). Once published, the docs can be found at [https://hexdocs.pm/ecto_adapters_dynamodb](https://hexdocs.pm/ecto_adapters_dynamodb).","ref":"readme.html#developer-notes","title":"Developer Notes - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"#","ref":"readme.html#upgrade-guides","title":"Upgrade guides - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Please see the instructions [here](upgrade_guides/version_1_upgrade_guide.md)\n\n#","ref":"readme.html#0-x-x-1-x-x","title":"0.X.X -> 1.X.X - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Please see the instructions [here](upgrade_guides/version_2_upgrade_guide.md)\n\n#","ref":"readme.html#1-x-x-2-x-x","title":"1.X.X -> 2.X.X - Ecto.Adapters.DynamoDB","type":"extras"},{"doc":"Please see the instructions [here](upgrade_guides/version_3_upgrade_guide.md)\n\n# License\nCopyright Circles Learning Labs\n\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use this project except in compliance with the License.","ref":"readme.html#2-x-x-3-x-x","title":"2.X.X -> 3.X.X - Ecto.Adapters.DynamoDB","type":"extras"}]}